# Jaida. Some styles

from hep.aida import *
from java.util import Random
from java.lang import Boolean
from jhplot import *


true = Boolean("true")
af   = IAnalysisFactory.create()
tree = af.createTreeFactory().create()
hf   = af.createHistogramFactory(tree)

h1 = hf.createHistogram1D("h1",100,-5,5)
h2 = hf.createHistogram1D("h2",100,-5,5)
h3 = hf.createHistogram1D("h3",100,-5,5)

r = Random()
for i in range(10000):
  h1.fill(r.nextGaussian())
  h2.fill(r.nextGaussian())
  h3.fill(r.nextGaussian())


c1=HPlotter("Histogram")
c1.visible()
regionStyle=c1.getRegionStyle()
regionStyle.dataStyle().setParameter("fillHistogramBars","false")
regionStyle.dataStyle().setParameter("showHistogramBars","true")
regionStyle.dataStyle().setParameter("showDataPoints","false")
regionStyle.dataStyle().setParameter("showErrorBars","false")
regionStyle.dataStyle().lineStyle().setParameter("color","black")
regionStyle.xAxisStyle().setLabel("E/m")
regionStyle.yAxisStyle().setLabel("# Evt")

regionStyle.setParameter("legendFont","Comics")
regionStyle.setParameter("legendFontSize","16")
regionStyle.setParameter("legendFontStyle","1")

regionStyle.setParameter("statisticsBoxFont","Comics")
regionStyle.setParameter("statisticsBoxFontSize","14")
regionStyle.setParameter("statisticsBoxFontStyle","2")

regionStyle.titleStyle().textStyle().setFontSize(30)
regionStyle.titleStyle().textStyle().setColor("orange")

regionStyle.xAxisStyle().labelStyle().setFontSize(24)
regionStyle.xAxisStyle().labelStyle().setItalic(true)
regionStyle.xAxisStyle().labelStyle().setColor("black")
regionStyle.xAxisStyle().tickLabelStyle().setFontSize(14)
regionStyle.xAxisStyle().tickLabelStyle().setBold(true)
regionStyle.xAxisStyle().tickLabelStyle().setColor("blue")

regionStyle.yAxisStyle().labelStyle().setFontSize(24)
regionStyle.yAxisStyle().labelStyle().setItalic(true)
regionStyle.yAxisStyle().labelStyle().setColor("brown")
regionStyle.yAxisStyle().tickLabelStyle().setFontSize(14)
regionStyle.yAxisStyle().tickLabelStyle().setBold(true)
regionStyle.yAxisStyle().tickLabelStyle().setColor("green")


dataStyle=c1.getDataStyle()
dataStyle.setParameter("showHistogramBars","false")
dataStyle.setParameter("showDataPoints","true")
dataStyle.markerStyle().setParameter("size","12")
dataStyle.markerStyle().setParameter("shape","3")
dataStyle.markerStyle().setParameter("color","blue")
c1.draw(h1)
c1.draw(h1,dataStyle)

#Create a new dataStyle to be used to plot the third histogram
dataStyle = c1.getDataStyle()
dataStyle.setParameter("showDataPoints","false")
dataStyle.setParameter("showErrorBars","true")
dataStyle.setParameter("showHistogramBars","false")
style = c1.getRegionStyle()
style.setParameter("errorBarsColor","green")
style.setDataStyle(dataStyle)
c1.draw(h3,style)
